(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('@progress/kendo-angular-buttons'), require('@progress/kendo-angular-treeview'), require('@angular/forms')) :
    typeof define === 'function' && define.amd ? define('angular-location-selector', ['exports', '@angular/core', '@angular/common', '@progress/kendo-angular-buttons', '@progress/kendo-angular-treeview', '@angular/forms'], factory) :
    (global = global || self, factory(global['angular-location-selector'] = {}, global.ng.core, global.ng.common, global.kendoAngularButtons, global.kendoAngularTreeview, global.ng.forms));
}(this, (function (exports, core, common, kendoAngularButtons, kendoAngularTreeview, forms) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    var __assign = function() {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); }
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }

    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    }

    function __createBinding(o, m, k, k2) {
        if (k2 === undefined) k2 = k;
        o[k2] = m[k];
    }

    function __exportStar(m, exports) {
        for (var p in m) if (p !== "default" && !exports.hasOwnProperty(p)) exports[p] = m[p];
    }

    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m) return m.call(o);
        if (o && typeof o.length === "number") return {
            next: function () {
                if (o && i >= o.length) o = void 0;
                return { value: o && o[i++], done: !o };
            }
        };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }

    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m) return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done) ar.push(r.value);
        }
        catch (error) { e = { error: error }; }
        finally {
            try {
                if (r && !r.done && (m = i["return"])) m.call(i);
            }
            finally { if (e) throw e.error; }
        }
        return ar;
    }

    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }

    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    };

    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }

    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n]) i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try { step(g[n](v)); } catch (e) { settle(q[0][3], e); } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length) resume(q[0][0], q[0][1]); }
    }

    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: n === "return" } : f ? f(v) : v; } : f; }
    }

    function __asyncValues(o) {
        if (!Symbol.asyncIterator) throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function(v) { resolve({ value: v, done: d }); }, reject); }
    }

    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
        return cooked;
    };

    function __importStar(mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
        result.default = mod;
        return result;
    }

    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }

    function __classPrivateFieldGet(receiver, privateMap) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to get private field on non-instance");
        }
        return privateMap.get(receiver);
    }

    function __classPrivateFieldSet(receiver, privateMap, value) {
        if (!privateMap.has(receiver)) {
            throw new TypeError("attempted to set private field on non-instance");
        }
        privateMap.set(receiver, value);
        return value;
    }

    var AngularLocationSelectorComponent = /** @class */ (function () {
        function AngularLocationSelectorComponent() {
            this.type = "single";
            this.selectedLocationId = null;
            this.selectedLocationName = 'Select';
            this.selectorDisabledLocation = false;
            this.onChange = new core.EventEmitter();
        }
        AngularLocationSelectorComponent.prototype.ngOnInit = function () {
        };
        AngularLocationSelectorComponent.prototype.onLocationsFetched = function (locations) {
            this.locationHierachy = locations;
        };
        AngularLocationSelectorComponent.prototype.updateLocationState = function (dataItem) {
            this.onChange.emit(dataItem);
        };
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "type", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "labelText", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "selectedLocationId", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "selectedLocationName", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "selectorDisabledLocation", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "locationHierachy", void 0);
        __decorate([
            core.Input()
        ], AngularLocationSelectorComponent.prototype, "hoverText", void 0);
        __decorate([
            core.Output()
        ], AngularLocationSelectorComponent.prototype, "onChange", void 0);
        AngularLocationSelectorComponent = __decorate([
            core.Component({
                selector: 'angular-location-selector',
                template: "<location-single-selector *ngIf=\"type == 'single'\" labelText=\"{{labelText}}\" class=\"location-selector-view\" [locationHierachy]=\"locationHierachy\"\r\nisDisableParentClick=\"false\" selectedLocationId=\"{{selectedLocationId}}\" hoverText=\"{{hoverText}}\"\r\nselectedLocationName=\"{{selectedLocationName}}\" isIncludeFloatLocation=\"true\"\r\n(onLocationsData)=\"onLocationsFetched($event)\" [selectorDisabled]=\"selectorDisabledLocation\" [hideBranchLess]=\"true\"\r\n(onChange)=\"updateLocationState($event)\">\r\n</location-single-selector>\r\n\r\n<location-multi-selector *ngIf=\"type == 'multi'\" labelText=\"{{labelText}}\" class=\"location-selector-view\" [locationHierachy]=\"locationHierachy\"\r\nisDisableParentClick=\"false\" selectedLocationId=\"{{selectedLocationId}}\" hoverText=\"{{hoverText}}\"\r\nselectedLocationName=\"{{selectedLocationName}}\" isIncludeFloatLocation=\"true\"\r\n(onLocationsData)=\"onLocationsFetched($event)\" [selectorDisabled]=\"selectorDisabledLocation\" [hideBranchLess]=\"true\"\r\n(onChange)=\"updateLocationState($event)\">\r\n</location-multi-selector>"
            })
        ], AngularLocationSelectorComponent);
        return AngularLocationSelectorComponent;
    }());

    var LocationMultiSelectorComponent = /** @class */ (function () {
        function LocationMultiSelectorComponent(elementRef) {
            this.elementRef = elementRef;
            this.expandedKeys = [];
            this.selectorOpened = false;
            this.selectedLocationName = "Select";
            this.selectedLocationId = 0;
            this.isIncludeFloatLocation = true;
            this.hideBranchLess = false;
            this.includeInactive = false;
            this.isDisableParentClick = false;
            this.onChange = new core.EventEmitter();
            this.page = "";
            this.checkedKeys = [];
            this.selectorDisabled = false;
            this.onLocationsData = new core.EventEmitter();
            this.selectedLocations = [];
        }
        LocationMultiSelectorComponent.prototype.ngOnInit = function () {
            this.onLocationsData.emit(this.locationHierachy);
            this.addExpandListItem(this.locationHierachy.locations);
            this.setDefaultValue(this.checkedKeys, this.locationHierachy.locations);
        };
        LocationMultiSelectorComponent.prototype.onGlobalClick = function (event) {
            if (!this.elementRef.nativeElement.contains(event.target)) {
                // clicked outside => close dropdown list
                this.selectorOpened = false;
            }
        };
        LocationMultiSelectorComponent.prototype.closeDropDown = function () {
            this.selectorOpened = false;
        };
        LocationMultiSelectorComponent.prototype.onItemSelected = function (data) {
            this.selectorOpened = false;
        };
        LocationMultiSelectorComponent.prototype.setDefaultValue = function (checkedKeys, items) {
            for (var i = 0; i < items.length; i++) {
                if (checkedKeys.indexOf(items[i].locationId) > -1) {
                    if (items[i].isSelectable) {
                        this.selectedLocations.push(items[i]);
                        this.setDefaultValue(checkedKeys, items[i].items);
                    }
                }
                else {
                    this.setDefaultValue(checkedKeys, items[i].items);
                }
            }
        };
        LocationMultiSelectorComponent.prototype.addExpandListItem = function (treeItem) {
            var _this = this;
            treeItem.forEach(function (item) {
                if (item.items && item.items.length > 0) {
                    _this.expandedKeys.push(item.locationId);
                    _this.addExpandListItem(item.items);
                }
            });
        };
        LocationMultiSelectorComponent.prototype.handleChange = function (data) {
            this.checkedKeys = data;
            var locationsFlatArray = this.locationHierachy.locationsFlatData;
            var selectedLocatonsArray = locationsFlatArray.filter(function (item) { return data.indexOf(item.locationId) !== -1; });
            this.selectedLocations = selectedLocatonsArray;
            this.onChange.emit(this.selectedLocations);
        };
        LocationMultiSelectorComponent.prototype.locationClick = function () {
            this.selectorOpened = !this.selectorOpened;
        };
        LocationMultiSelectorComponent.prototype.onRemove = function (item) {
            var index = this.selectedLocations.findIndex(function (c) { return c.locationId === item.locationId; });
            var checkedKeyIndex = this.checkedKeys.findIndex(function (k) { return k == item.locationId; });
            this.checkedKeys.splice(checkedKeyIndex, 1);
            this.selectedLocations.splice(index, 1);
            this.onChange.emit(this.selectedLocations);
        };
        LocationMultiSelectorComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "selectedLocationName", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "selectedLocationId", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "labelText", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "hoverText", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "isIncludeFloatLocation", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "hideBranchLess", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "includeInactive", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "isDisableParentClick", void 0);
        __decorate([
            core.Output()
        ], LocationMultiSelectorComponent.prototype, "onChange", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "locationHierachy", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "page", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "checkedKeys", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorComponent.prototype, "selectorDisabled", void 0);
        __decorate([
            core.Output()
        ], LocationMultiSelectorComponent.prototype, "onLocationsData", void 0);
        __decorate([
            core.HostListener('document:mousedown', ['$event'])
        ], LocationMultiSelectorComponent.prototype, "onGlobalClick", null);
        LocationMultiSelectorComponent = __decorate([
            core.Component({
                selector: 'location-multi-selector',
                template: "<div class=\"row align-items-center\" (click)=\"closeDropDown()\">\r\n  <div class=\"col-md-12\">\r\n    <label *ngIf=\"labelText?.length > 0\">{{labelText}}</label>\r\n\r\n    <div #menu class=\"d-flex justify-content-between location-selector-form\"\r\n      [ngClass]=\"{'disableSelector':selectorDisabled,'location-selector-focus' : selectorOpened}\" id=\"ddlLocationy\"\r\n      (click)=\"locationClick()\" [title]=\"hoverText\" (click)=\"$event.stopPropagation()\">\r\n      <div >\r\n        <span *ngIf=\"selectorDisabled && selectedLocations.length<1\">\r\n          {{selectedLocationName}}\r\n        </span>\r\n        <span *ngIf=\"!selectorDisabled && selectedLocations.length<1\">\r\n          Select\r\n        </span>\r\n        <kendo-chip *ngFor=\"let selectedLocation of selectedLocations.slice(0,3)\"\r\n          [label]=\"selectedLocation.locationName\" removable=\"true\"  removeIcon=\"k-icon k-i-close\"\r\n          (remove)=\"onRemove(selectedLocation);\">\r\n        </kendo-chip>\r\n      </div>\r\n      <div class=\"d-flex flex-column align-items-center ml-1\">\r\n        <em class=\"fas fa-chevron-down\"></em>\r\n        <span *ngIf=\"selectedLocations?.length >3\">+{{selectedLocations?.length-3}}\r\n        </span>\r\n      </div>\r\n    </div>\r\n    <div class=\"location-tree-wrapper p-2\" *ngIf=\"selectorOpened\" (click)=\"$event.stopPropagation()\">\r\n      <location-multi-selector-tree-view [locations]=\"locationHierachy.locations\"\r\n        [expandedKeys]=\"expandedKeys\" \r\n        [selectedLocationId]=\"selectedLocationId\" [checkedKeys]=\"checkedKeys\" (onChange)=\"handleChange($event)\"\r\n        (closeEvent)=\"onItemSelected($event)\">\r\n      </location-multi-selector-tree-view>\r\n    </div>\r\n  </div>\r\n</div>",
                styles: [":host ::ng-deep .location-selector-form{align-items:center;background-color:#fff;background-clip:padding-box;border:1px solid #ced4da;border-radius:.25rem;color:#495057;cursor:pointer;display:block;font-size:.9rem;height:auto;font-weight:400;line-height:1.5;padding:.2rem .4rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out;width:300px}:host ::ng-deep .location-selector-focus{background-color:#fff;box-shadow:0 0 0 .2rem rgba(0,81,81,.1);color:#495057;outline:0}:host ::ng-deep .location-tree-wrapper{position:absolute;z-index:10}:host ::ng-deep .disableSelector{opacity:.6;pointer-events:none}.k-chip{color:#fff;margin:2px;background-color:#005151;float:left;border-radius:4px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;max-width:120px}.k-chip:last-child{max-width:230px}"]
            })
        ], LocationMultiSelectorComponent);
        return LocationMultiSelectorComponent;
    }());

    var LocationMultiSelectorTreeViewComponent = /** @class */ (function () {
        function LocationMultiSelectorTreeViewComponent(cdRef) {
            this.cdRef = cdRef;
            this.closeEvent = new core.EventEmitter();
            this.onChange = new core.EventEmitter();
            this.locationSelector = {
                id: 0,
                locationName: null,
                locationCode: null,
                utcoffsetInMinutes: 0,
                locationTypeId: 0,
                timezoneId: null,
                timeZoneName: null,
                dropDownDisabled: null,
                lastLocationAutoWraupTime: null
            };
            // currently checked Tree view unique id
            this.checkedKeys = [];
            this.checkAll = true;
            // Checking component
            this.key = 'locationId';
        }
        LocationMultiSelectorTreeViewComponent.prototype.ngOnChanges = function (changes) {
            this.checkDefaultValue(changes.checkedKeys.currentValue, this.locations);
        };
        LocationMultiSelectorTreeViewComponent.prototype.ngOnInit = function () {
            this.checkDefaultValue(this.checkedKeys, this.locations);
            this.onChange.emit(this.checkedKeys);
        };
        LocationMultiSelectorTreeViewComponent.prototype.ngAfterContentInit = function () {
            this.addExpandListItem(this.locations);
        };
        LocationMultiSelectorTreeViewComponent.prototype.ngAfterViewInit = function () {
            this.cdRef.detectChanges();
        };
        LocationMultiSelectorTreeViewComponent.prototype.checkDefaultValue = function (checkedKeys, items) {
            for (var i = 0; i < items.length; i++) {
                if (checkedKeys.indexOf(items[i].locationId) > -1) {
                    if (items[i].isSelectable) {
                        items[i].isSelected = true;
                        this.checkDefaultValue(checkedKeys, items[i].items);
                    }
                    else {
                        items[i].isSelected = false;
                    }
                }
                else {
                    items[i].isSelected = false;
                    this.checkDefaultValue(checkedKeys, items[i].items);
                }
            }
        };
        LocationMultiSelectorTreeViewComponent.prototype.handleCheck = function (dataItem) {
            dataItem.isSelected = !dataItem.isSelected;
            this.handleChildCheck(dataItem.items, dataItem.isSelected);
            this.checkedKeys = [];
            this.checkedKeys = this.getCheckedKeys(this.locations, this.checkedKeys);
            this.onChange.emit(this.checkedKeys);
        };
        LocationMultiSelectorTreeViewComponent.prototype.handleChildCheck = function (childItems, isSelected) {
            for (var i = 0; i < childItems.length; i++) {
                if (childItems[i].isSelectable) {
                    childItems[i].isSelected = isSelected;
                    this.handleChildCheck(childItems[i].items, isSelected);
                }
            }
        };
        LocationMultiSelectorTreeViewComponent.prototype.unCheckAll = function (items) {
            for (var i = 0; i < items.length; i++) {
                if (items[i].isSelectable) {
                    items[i].isSelected = false;
                    this.unCheckAll(items[i].items);
                }
            }
        };
        LocationMultiSelectorTreeViewComponent.prototype.getCheckedKeys = function (items, keys) {
            for (var i = 0; i < items.length; i++) {
                if (items[i].isSelected) {
                    keys.push(items[i].locationId);
                }
                keys = this.getCheckedKeys(items[i].items, keys);
            }
            return keys;
        };
        LocationMultiSelectorTreeViewComponent.prototype.showClick = function (dataItem) {
            var _a, _b, _c, _d, _e, _f, _g, _h;
            this.locationSelector = {
                id: (_a = dataItem) === null || _a === void 0 ? void 0 : _a.locationId,
                locationName: (_b = dataItem) === null || _b === void 0 ? void 0 : _b.locationName,
                locationCode: (_c = dataItem) === null || _c === void 0 ? void 0 : _c.locationCode,
                locationTypeId: (_d = dataItem) === null || _d === void 0 ? void 0 : _d.locationTypeId,
                utcoffsetInMinutes: (_e = dataItem) === null || _e === void 0 ? void 0 : _e.utcoffsetInMinutes,
                timezoneId: (_f = dataItem) === null || _f === void 0 ? void 0 : _f.timezoneId,
                timeZoneName: (_g = dataItem) === null || _g === void 0 ? void 0 : _g.timeZoneName,
                dropDownDisabled: null,
                lastLocationAutoWraupTime: (_h = dataItem) === null || _h === void 0 ? void 0 : _h.lastLocationAutoWraupTime
            };
            this.closeEvent.emit(this.locationSelector);
        };
        LocationMultiSelectorTreeViewComponent.prototype.addExpandListItem = function (treeItem) {
            var _this = this;
            treeItem.forEach(function (item) {
                if (item.hasChild) {
                    _this.addExpandListItem(item.items);
                }
            });
        };
        LocationMultiSelectorTreeViewComponent.ctorParameters = function () { return [
            { type: core.ChangeDetectorRef }
        ]; };
        __decorate([
            core.Input()
        ], LocationMultiSelectorTreeViewComponent.prototype, "expandedKeys", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorTreeViewComponent.prototype, "selectedLocationId", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorTreeViewComponent.prototype, "locations", void 0);
        __decorate([
            core.Output()
        ], LocationMultiSelectorTreeViewComponent.prototype, "closeEvent", void 0);
        __decorate([
            core.Output()
        ], LocationMultiSelectorTreeViewComponent.prototype, "onChange", void 0);
        __decorate([
            core.Input()
        ], LocationMultiSelectorTreeViewComponent.prototype, "checkedKeys", void 0);
        LocationMultiSelectorTreeViewComponent = __decorate([
            core.Component({
                selector: 'location-multi-selector-tree-view',
                template: "<kendo-treeview [nodes]=\"locations\" textField=\"locationName\" childrenField=\"items\" \r\n[(expandedKeys)]=\"expandedKeys\" expandBy=\"locationId\" \r\n[filterable]=\"true\"     \r\n  filterInputPlaceholder=\"Search\" kendoTreeViewExpandable   \r\n      kendoTreeViewHierarchyBinding>\r\n      <ng-template kendoTreeViewNodeTemplate let-dataItem>\r\n        <input [(ngModel)]=\"dataItem.isSelected\" (click)=\"handleCheck(dataItem)\" [disabled]=\"!dataItem.isSelectable\"  class=\"k-checkbox\" type=\"checkbox\"\r\n        kendoCheckBox /><span class=\"selectoritem\" (click)=\"handleCheck(dataItem)\"   [ngClass]=\"{'disableNode': dataItem.isSelectable === false,'itemactive' : selectedLocationId == dataItem.locationId}\">        \r\n        {{ dataItem.locationName }}  \r\n       </span>\r\n       \r\n      </ng-template>\r\n</kendo-treeview>\r\n",
                styles: [":host ::ng-deep .k-checkbox{border-color:#000}:host ::ng-deep .k-textbox{width:100%;margin-bottom:8px}:host ::ng-deep .k-in.k-state-focused{box-shadow:none!important}:host ::ng-deep .selectoritem:hover{background-color:#005151;border-radius:3px;color:#fff;font-weight:500;cursor:default}:host ::ng-deep .k-treeview .k-icon{font-size:20px}:host ::ng-deep .k-treeview .k-in{padding:0;width:100%}:host ::ng-deep .selectoritem{padding:5px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}:host ::ng-deep .disableNode{opacity:.6;pointer-events:none}:host ::ng-deep .itemactive{color:#005151;font-weight:500}"]
            })
        ], LocationMultiSelectorTreeViewComponent);
        return LocationMultiSelectorTreeViewComponent;
    }());

    var LocationMultiSelectorModule = /** @class */ (function () {
        function LocationMultiSelectorModule() {
        }
        LocationMultiSelectorModule = __decorate([
            core.NgModule({
                declarations: [
                    LocationMultiSelectorTreeViewComponent,
                    LocationMultiSelectorComponent
                ],
                imports: [
                    common.CommonModule,
                    forms.FormsModule,
                    kendoAngularButtons.ButtonsModule,
                    kendoAngularTreeview.TreeViewModule
                ],
                exports: [
                    LocationMultiSelectorComponent
                ],
                entryComponents: [LocationMultiSelectorComponent]
            })
        ], LocationMultiSelectorModule);
        return LocationMultiSelectorModule;
    }());

    var LocationSingleSelectorComponent = /** @class */ (function () {
        function LocationSingleSelectorComponent(elementRef) {
            this.elementRef = elementRef;
            this.expandedKeys = [];
            this.selectorOpened = false;
            this.disableSelector = false;
            this.selectedLocationName = "Select";
            this.selectedLocationId = 0;
            this.isIncludeFloatLocation = true;
            this.isDisableParentClick = false;
            this.page = "";
            this.hideBranchLess = false;
            this.selectableTypes = []; // an array of location types to be made selectable
            this.selectorDisabled = false;
            this.onChange = new core.EventEmitter();
            this.onLocationsData = new core.EventEmitter();
        }
        LocationSingleSelectorComponent.prototype.ngOnInit = function () {
            var _this = this;
            this.onLocationsData.emit(this.locationHierachy);
            if (this.selectableTypes.length > 0)
                this.locationHierachy.locations[0] = this.makeSelectableByLocationType(this.locationHierachy.locations[0]);
            if (this.locationHierachy.locations.length > 0 && this.locationHierachy.locations[0].items == null) {
                this.disableSelector = true;
                this.selectedLocationName = "No branches available";
            }
            else if (this.selectedLocationName == null && this.selectedLocationId != null) {
                // if a location name is not passed in as an input, we set it using the locationId
                this.selectedLocationName = this.locationHierachy.locationsFlatData.find(function (l) { return l.locationId == _this.selectedLocationId; }).locationName;
            }
            this.addExpandListItem(this.locationHierachy.locations);
            this.setDropDownState();
        };
        LocationSingleSelectorComponent.prototype.makeSelectableByLocationType = function (locations) {
            var _this = this;
            locations.isSelectable = this.selectableTypes.includes(locations.locationTypeId);
            if (locations.hasChild) {
                locations.items.forEach(function (i) { return _this.makeSelectableByLocationType(i); });
            }
            return locations;
        };
        LocationSingleSelectorComponent.prototype.setDropDownState = function () {
            this.disableSelector = this.selectorDisabled;
        };
        LocationSingleSelectorComponent.prototype.onGlobalClick = function (event) {
            if (!this.elementRef.nativeElement.contains(event.target)) {
                // clicked outside => close dropdown list
                this.selectorOpened = false;
            }
        };
        LocationSingleSelectorComponent.prototype.closeDropDown = function () {
            this.selectorOpened = false;
        };
        LocationSingleSelectorComponent.prototype.onItemSelected = function (data) {
            this.selectorOpened = false;
            this.onChange.emit(data);
            this.selectedLocationName = data.locationName;
        };
        LocationSingleSelectorComponent.prototype.addExpandListItem = function (treeItem) {
            var _this = this;
            treeItem.forEach(function (item) {
                if (item.items && item.items.length > 0) {
                    _this.expandedKeys.push(item.locationId);
                    _this.addExpandListItem(item.items);
                }
            });
        };
        LocationSingleSelectorComponent.prototype.locationClick = function () {
            if (!this.selectorDisabled) {
                this.selectorOpened = !this.selectorOpened;
            }
        };
        LocationSingleSelectorComponent.ctorParameters = function () { return [
            { type: core.ElementRef }
        ]; };
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "selectedLocationName", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "selectedLocationId", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "labelText", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "hoverText", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "isIncludeFloatLocation", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "isDisableParentClick", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "page", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "hideBranchLess", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "selectableTypes", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "selectorDisabled", void 0);
        __decorate([
            core.Output()
        ], LocationSingleSelectorComponent.prototype, "onChange", void 0);
        __decorate([
            core.Output()
        ], LocationSingleSelectorComponent.prototype, "onLocationsData", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorComponent.prototype, "locationHierachy", void 0);
        __decorate([
            core.HostListener('document:mousedown', ['$event'])
        ], LocationSingleSelectorComponent.prototype, "onGlobalClick", null);
        LocationSingleSelectorComponent = __decorate([
            core.Component({
                selector: 'location-single-selector',
                template: "<div class=\"row align-items-center\" (click)=\"closeDropDown()\">\r\n  <div class=\"col-md-12\">\r\n    <label *ngIf=\"labelText?.length > 0\">{{labelText}}</label>\r\n\r\n    <div #menu class=\"d-flex justify-content-between location-selector-form\"\r\n      [ngClass]=\"{'disableSelector':selectorDisabled,'location-selector-focus' : selectorOpened}\" id=\"ddlLocationy\"\r\n      (click)=\"locationClick()\" (click)=\"$event.stopPropagation()\" [title]=\"hoverText\">\r\n      <div class=\"selected-location\">{{selectedLocationName}}</div>\r\n      <div><em class=\"fas fa-chevron-down\"></em></div>\r\n    </div>\r\n    <div class=\"location-tree-wrapper p-2\" *ngIf=\"selectorOpened\" (click)=\"$event.stopPropagation()\">\r\n      <location-single-selector-tree-view [locations]=\"locationHierachy.locations\" [expandedKeys]=\"expandedKeys\"\r\n        [selectedLocationId]=\"selectedLocationId\" (closeEvent)=\"onItemSelected($event)\">\r\n      </location-single-selector-tree-view>\r\n    </div>\r\n  </div>\r\n</div>",
                styles: [":host ::ng-deep .location-selector-form{cursor:pointer;display:block;width:300px;height:calc(1.5em + .75rem + 2px);padding:.375rem .75rem;font-size:.9rem;font-weight:400;line-height:1.5;color:#495057;background-color:#fff;background-clip:padding-box;border:1px solid #ced4da;border-radius:.25rem;transition:border-color .15s ease-in-out,box-shadow .15s ease-in-out}:host ::ng-deep .location-selector-focus{color:#495057;background-color:#fff;outline:0;box-shadow:0 0 0 .2rem rgba(0,81,81,.1)}:host ::ng-deep .location-tree-wrapper{position:absolute;z-index:10}:host ::ng-deep .disableSelector{opacity:.6;cursor:default}.selected-location{overflow:hidden;text-overflow:ellipsis;white-space:nowrap;width:350px}"]
            })
        ], LocationSingleSelectorComponent);
        return LocationSingleSelectorComponent;
    }());

    var LocationSingleSelectorTreeViewComponent = /** @class */ (function () {
        function LocationSingleSelectorTreeViewComponent() {
            this.closeEvent = new core.EventEmitter();
            this.locationSelector = {
                id: 0,
                locationName: null,
                locationCode: null,
                utcoffsetInMinutes: 0,
                locationTypeId: 0,
                timezoneId: null,
                timeZoneName: null,
                dropDownDisabled: null,
                lastLocationAutoWraupTime: null
            };
        }
        LocationSingleSelectorTreeViewComponent.prototype.ngOnInit = function () {
        };
        LocationSingleSelectorTreeViewComponent.prototype.ngAfterContentInit = function () {
            this.addExpandListItem(this.locations);
        };
        LocationSingleSelectorTreeViewComponent.prototype.showClick = function (dataItem) {
            var _a, _b, _c, _d, _e, _f, _g, _h;
            this.locationSelector = {
                id: (_a = dataItem) === null || _a === void 0 ? void 0 : _a.locationId,
                locationName: (_b = dataItem) === null || _b === void 0 ? void 0 : _b.locationName,
                locationCode: (_c = dataItem) === null || _c === void 0 ? void 0 : _c.locationCode,
                locationTypeId: (_d = dataItem) === null || _d === void 0 ? void 0 : _d.locationTypeId,
                utcoffsetInMinutes: (_e = dataItem) === null || _e === void 0 ? void 0 : _e.utcoffsetInMinutes,
                timezoneId: (_f = dataItem) === null || _f === void 0 ? void 0 : _f.timeZoneId,
                timeZoneName: (_g = dataItem) === null || _g === void 0 ? void 0 : _g.timeZoneName,
                dropDownDisabled: null,
                lastLocationAutoWraupTime: (_h = dataItem) === null || _h === void 0 ? void 0 : _h.lastLocationAutoWraupTime
            };
            this.closeEvent.emit(this.locationSelector);
        };
        LocationSingleSelectorTreeViewComponent.prototype.addExpandListItem = function (treeItem) {
            var _this = this;
            treeItem.forEach(function (item) {
                if (item.hasChild) {
                    _this.addExpandListItem(item.items);
                }
            });
        };
        __decorate([
            core.Input()
        ], LocationSingleSelectorTreeViewComponent.prototype, "expandedKeys", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorTreeViewComponent.prototype, "selectedLocationId", void 0);
        __decorate([
            core.Input()
        ], LocationSingleSelectorTreeViewComponent.prototype, "locations", void 0);
        __decorate([
            core.Output()
        ], LocationSingleSelectorTreeViewComponent.prototype, "closeEvent", void 0);
        LocationSingleSelectorTreeViewComponent = __decorate([
            core.Component({
                selector: 'location-single-selector-tree-view',
                template: "<kendo-treeview [nodes]=\"locations\" textField=\"locationName\" childrenField=\"items\" \r\n[(expandedKeys)]=\"expandedKeys\" expandBy=\"locationId\" \r\n[filterable]=\"true\"      \r\n  filterInputPlaceholder=\"Search\" kendoTreeViewExpandable   \r\n      kendoTreeViewHierarchyBinding>\r\n      <ng-template kendoTreeViewNodeTemplate let-dataItem >\r\n       <span   class=\"selectoritem\" (click)=\"showClick(dataItem)\"  [ngClass]=\"{'disableNode': dataItem.isSelectable === false,'itemactive' : selectedLocationId == dataItem.locationId}\">        \r\n        {{ dataItem.locationName }}  \r\n       </span>   \r\n      </ng-template>\r\n</kendo-treeview>",
                styles: [":host ::ng-deep .k-checkbox{border-color:#000}:host ::ng-deep .k-textbox{width:100%;margin-bottom:8px}:host ::ng-deep .k-in.k-state-focused{box-shadow:none!important}:host ::ng-deep .selectoritem:hover{background-color:#005151;border-radius:3px;color:#fff;font-weight:500;cursor:default}:host ::ng-deep .k-treeview .k-icon{font-size:20px}:host ::ng-deep .k-treeview .k-in{padding:0;width:100%}:host ::ng-deep .selectoritem{padding:5px;white-space:nowrap;overflow:hidden;text-overflow:ellipsis;width:100%}:host ::ng-deep .disableNode{opacity:.6;pointer-events:none}:host ::ng-deep .itemactive{color:#005151;font-weight:500}"]
            })
        ], LocationSingleSelectorTreeViewComponent);
        return LocationSingleSelectorTreeViewComponent;
    }());

    var LocationSingleSelectorModule = /** @class */ (function () {
        function LocationSingleSelectorModule() {
        }
        LocationSingleSelectorModule = __decorate([
            core.NgModule({
                declarations: [
                    LocationSingleSelectorTreeViewComponent,
                    LocationSingleSelectorComponent,
                ],
                imports: [
                    common.CommonModule,
                    kendoAngularTreeview.TreeViewModule
                ],
                exports: [
                    LocationSingleSelectorComponent
                ],
                entryComponents: [LocationSingleSelectorComponent],
            })
        ], LocationSingleSelectorModule);
        return LocationSingleSelectorModule;
    }());

    var AngularLocationSelectorModule = /** @class */ (function () {
        function AngularLocationSelectorModule() {
        }
        AngularLocationSelectorModule = __decorate([
            core.NgModule({
                declarations: [AngularLocationSelectorComponent],
                imports: [
                    LocationSingleSelectorModule,
                    LocationMultiSelectorModule,
                    common.CommonModule
                ],
                exports: [AngularLocationSelectorComponent]
            })
        ], AngularLocationSelectorModule);
        return AngularLocationSelectorModule;
    }());

    exports.AngularLocationSelectorComponent = AngularLocationSelectorComponent;
    exports.AngularLocationSelectorModule = AngularLocationSelectorModule;
    exports.ɵa = LocationSingleSelectorModule;
    exports.ɵb = LocationSingleSelectorTreeViewComponent;
    exports.ɵc = LocationSingleSelectorComponent;
    exports.ɵd = LocationMultiSelectorModule;
    exports.ɵe = LocationMultiSelectorTreeViewComponent;
    exports.ɵf = LocationMultiSelectorComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=angular-location-selector.umd.js.map
