import { EventEmitter, OnInit } from '@angular/core';
import { LocationSelector } from './models/location-selector/location-selector-model';
import { LocationSelectorInfo } from './models/locationSelectorModel';
export declare class AngularLocationSelectorComponent implements OnInit {
    type: string;
    labelText: string;
    selectedLocationId: number;
    selectedLocationName: string;
    selectorDisabledLocation: boolean;
    locationHierachy: LocationSelector;
    hoverText: string;
    onChange: EventEmitter<any>;
    constructor();
    ngOnInit(): void;
    onLocationsFetched(locations: LocationSelector): void;
    updateLocationState(dataItem: LocationSelectorInfo): void;
}
