import { ChangeDetectorRef, EventEmitter, OnInit, SimpleChanges } from '@angular/core';
import { LocationMultiSelectorModel } from '../../models/location-multi-selector.model';
import { LocationSelectorInfo } from '../../models/locationSelectorModel';
export declare class LocationMultiSelectorTreeViewComponent implements OnInit {
    private cdRef;
    expandedKeys: any[];
    selectedLocationId: number;
    locations: LocationMultiSelectorModel[];
    closeEvent: EventEmitter<LocationSelectorInfo>;
    onChange: EventEmitter<any>;
    locationSelector: LocationSelectorInfo;
    checkedKeys: any[];
    ngOnChanges(changes: SimpleChanges): void;
    checkAll: boolean;
    key: string;
    iterableDiffer: any;
    constructor(cdRef: ChangeDetectorRef);
    ngOnInit(): void;
    ngAfterContentInit(): void;
    ngAfterViewInit(): void;
    checkDefaultValue(checkedKeys: number[], items: LocationMultiSelectorModel[]): void;
    handleCheck(dataItem: LocationMultiSelectorModel): void;
    handleChildCheck(childItems: LocationMultiSelectorModel[], isSelected: boolean): void;
    unCheckAll(items: LocationMultiSelectorModel[]): void;
    getCheckedKeys(items: LocationMultiSelectorModel[], keys: number[]): number[];
    showClick(dataItem: any): void;
    private addExpandListItem;
}
