import { ElementRef, EventEmitter, OnInit } from '@angular/core';
import { LocationMultiSelectorModel } from '../models/location-multi-selector.model';
import { LocationMultiSelector } from '../models/location-selector/location-multi-selector-model';
import { LocationDropDownModel } from '../models/locations-drop-down-list.model';
import { LocationSelectorInfo } from '../models/locationSelectorModel';
export declare class LocationMultiSelectorComponent implements OnInit {
    private elementRef;
    expandedKeys: any[];
    selectorOpened: boolean;
    selectedLocationName: string;
    selectedLocationId: number;
    labelText: string;
    hoverText: string;
    isIncludeFloatLocation: boolean;
    hideBranchLess: boolean;
    includeInactive: boolean;
    isDisableParentClick: boolean;
    onChange: EventEmitter<LocationMultiSelectorModel[]>;
    locationHierachy: LocationMultiSelector;
    page: string;
    checkedKeys: any[];
    selectorDisabled: boolean;
    onLocationsData: EventEmitter<LocationMultiSelector>;
    selectedLocations: LocationMultiSelectorModel[];
    constructor(elementRef: ElementRef);
    ngOnInit(): void;
    onGlobalClick(event: any): void;
    closeDropDown(): void;
    onItemSelected(data: LocationSelectorInfo): void;
    setDefaultValue(checkedKeys: number[], items: LocationMultiSelectorModel[]): void;
    private addExpandListItem;
    handleChange(data: any): void;
    locationClick(): void;
    onRemove(item: LocationDropDownModel): void;
}
